'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilsBootstrapUtils = require('./utils/bootstrapUtils');

var _utilsBootstrapUtils2 = _interopRequireDefault(_utilsBootstrapUtils);

var _domHelpersUtilScrollbarSize = require('dom-helpers/util/scrollbarSize');

var _domHelpersUtilScrollbarSize2 = _interopRequireDefault(_domHelpersUtilScrollbarSize);

var _domHelpersUtilInDOM = require('dom-helpers/util/inDOM');

var _domHelpersUtilInDOM2 = _interopRequireDefault(_domHelpersUtilInDOM);

var _domHelpersOwnerDocument = require('dom-helpers/ownerDocument');

var _domHelpersOwnerDocument2 = _interopRequireDefault(_domHelpersOwnerDocument);

var _domHelpersEvents = require('dom-helpers/events');

var _domHelpersEvents2 = _interopRequireDefault(_domHelpersEvents);

var _Fade = require('./Fade');

var _Fade2 = _interopRequireDefault(_Fade);

var _reactOverlaysLibModal = require('react-overlays/lib/Modal');

var _reactOverlaysLibModal2 = _interopRequireDefault(_reactOverlaysLibModal);

var _reactOverlaysLibUtilsIsOverflowing = require('react-overlays/lib/utils/isOverflowing');

var _reactOverlaysLibUtilsIsOverflowing2 = _interopRequireDefault(_reactOverlaysLibUtilsIsOverflowing);

var Loading = (function (_React$Component) {
  _inherits(Loading, _React$Component);

  function Loading() {
    var _this2 = this;

    _classCallCheck(this, Loading);

    _React$Component.apply(this, arguments);

    this.state = {
      modalStyles: {}
    };

    this.renderLoading = function () {
      var _props = _this2.props;
      var className = _props.className;
      var children = _props.children;
      var animation = _props.animation;
      var containerId = _props.containerId;

      var props = _objectWithoutProperties(_props, ['className', 'children', 'animation', 'containerId']);

      var modalStyles = _this2.state.modalStyles;

      var _this = _this2;

      var inClass = { 'in': props.show && !animation };

      var container = undefined;
      if (containerId) {
        container = document.getElementById(containerId);
      }

      var loading = _react2['default'].createElement(
        'div',
        {
          className: 'loading-wrapper',
          style: modalStyles,
          ref: function (ref) {
            return _this2._loading = ref;
          } },
        _react2['default'].createElement('span', { className: 'fontelloicon glyphicon-spinner2' }),
        children
      );

      var loadingModal = _react2['default'].createElement(
        _reactOverlaysLibModal2['default'],
        {
          role: 'loading-modal',
          show: props.show,
          ref: function (ref) {
            _this2._wrapper = ref && ref.refs.modal;
            _this2._backdrop = ref && ref.refs.backdrop;
            _this2._loadingModal = ref;
          },
          autoFocus: false,
          enforceFocus: false,
          onEntering: _this2._onShow,
          onExited: _this2._onHide,
          backdrop: props.backdrop,
          backdropClassName: _classnames2['default'](_utilsBootstrapUtils2['default'].prefix(props, 'backdrop'), inClass),
          container: container || props.container,
          containerClassName: _utilsBootstrapUtils2['default'].prefix(props, 'open'),
          transition: animation ? _Fade2['default'] : undefined,
          dialogTransitionTimeout: Loading.TRANSITION_DURATION,
          backdropTransitionTimeout: Loading.BACKDROP_TRANSITION_DURATION
        },
        loading
      );

      _this2._mountLoadingTarget();
      _reactDom2['default'].unstable_renderSubtreeIntoContainer(_this2, loadingModal, _this2._loadingTarget);
    };

    this._mountLoadingTarget = function () {
      if (!_this2._loadingTarget) {
        _this2._loadingTarget = document.createElement('div');
        _this2._getLoadingContainerDOMNode().appendChild(_this2._loadingTarget);
      }
    };

    this._getLoadingContainerDOMNode = function () {
      var node = _reactDom2['default'].findDOMNode(_this2),
          body = document.body;
      return node ? node.parentNode || body : body;
    };

    this._onShow = function () {
      _domHelpersEvents2['default'].on(window, 'resize', _this2.handleWindowResize);

      _this2.setState(_this2._getStyles());

      if (_this2.props.onEntering) {
        var _props2;

        (_props2 = _this2.props).onEntering.apply(_props2, arguments);
      }
    };

    this._onHide = function () {
      _domHelpersEvents2['default'].off(window, 'resize', _this2.handleWindowResize);

      if (_this2.props.onExited) {
        var _props3;

        (_props3 = _this2.props).onExited.apply(_props3, arguments);
      }
    };

    this.handleWindowResize = function () {
      _this2.setState(_this2._getStyles());
    };

    this._getStyles = function () {
      if (!_domHelpersUtilInDOM2['default']) {
        return {};
      }

      var node = _reactDom2['default'].findDOMNode(_this2._loading);
      var doc = _domHelpersOwnerDocument2['default'](node);

      var scrollHt = node.scrollHeight;
      var bodyIsOverflowing = _reactOverlaysLibUtilsIsOverflowing2['default'](_reactDom2['default'].findDOMNode(_this2.props.container || doc.body));
      var modalIsOverflowing = scrollHt > doc.documentElement.clientHeight;

      return {
        modalStyles: {
          marginTop: -node.offsetHeight / 2,
          marginLeft: -node.offsetWidth / 2,
          paddingRight: bodyIsOverflowing && !modalIsOverflowing ? _domHelpersUtilScrollbarSize2['default']() : void 0,
          paddingLeft: !bodyIsOverflowing && modalIsOverflowing ? _domHelpersUtilScrollbarSize2['default']() : void 0
        }
      };
    };
  }

  Loading.prototype.render = function render() {
    return null;
  };

  Loading.prototype.componentDidUpdate = function componentDidUpdate() {
    this.renderLoading();
  };

  Loading.prototype.componentDidMount = function componentDidMount() {
    this.renderLoading();
  };

  _createClass(Loading, null, [{
    key: 'defaultProps',
    value: _extends({}, _reactOverlaysLibModal2['default'].defaultProps, {
      animation: true
    }),
    enumerable: true
  }]);

  return Loading;
})(_react2['default'].Component);

Loading.TRANSITION_DURATION = 300;
Loading.BACKDROP_TRANSITION_DURATION = 150;

exports['default'] = _utilsBootstrapUtils.bsClass('loading', Loading);
module.exports = exports['default'];