'use strict';

var _extends = require('babel-runtime/helpers/extends')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _utilsBootstrapUtils = require('./utils/bootstrapUtils');

var _utilsBootstrapUtils2 = _interopRequireDefault(_utilsBootstrapUtils);

var _Overlay = require('./Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var TipChild = function TipChild(props) {
  var arrowOffsetLeft = props.arrowOffsetLeft;
  var arrowOffsetTop = props.arrowOffsetTop;
  var positionLeft = props.positionLeft;
  var positionTop = props.positionTop;

  var otherProps = _objectWithoutProperties(props, ['arrowOffsetLeft', 'arrowOffsetTop', 'positionLeft', 'positionTop']);

  var child = _react2['default'].Children.only(props.children);
  return _react.cloneElement(child, _extends({}, otherProps));
};

var Tip = (function (_React$Component) {
  _inherits(Tip, _React$Component);

  function Tip() {
    var _this = this;

    _classCallCheck(this, Tip);

    _React$Component.apply(this, arguments);

    this.state = {
      marginTop: 0,
      marginLeft: 0
    };

    this.createTimer = function () {
      var node = _this.topTip;
      if (node) {
        node.style.marginLeft = -node.clientWidth / 2;
        node.style.marginTop = -node.clientHeight / 2;
      }
      // 如果存在定时器则执行
      if (_this.props.timeout && _this.props.onDismiss && _this.props.show) {
        _this.dismissTimer = setTimeout(_this.props.onDismiss, _this.props.timeout);
      }
    };
  }

  Tip.prototype.render = function render() {
    var _this2 = this;

    var tipClass = 'msg-tips-pop tips-' + this.props.status;

    return _react2['default'].createElement(
      _Overlay2['default'],
      this.props,
      _react2['default'].createElement(
        TipChild,
        null,
        _react2['default'].createElement(
          'div',
          null,
          _react2['default'].createElement(
            'div',
            { className: tipClass, ref: function (node) {
                _this2.topTip = node;
              } },
            _react2['default'].createElement(
              'div',
              { className: 'tips-content' },
              this.props.children
            )
          )
        )
      )
    );
  };

  Tip.prototype.componentDidMount = function componentDidMount() {
    this.createTimer();
  };

  Tip.prototype.componentDidUpdate = function componentDidUpdate(nextProps) {
    this.createTimer();
  };

  return Tip;
})(_react2['default'].Component);

Tip.propTypes = {
  /**
   * status
   *
   */
  status: _propTypes2['default'].oneOf(['error', 'success']),
  /**
   * 消失执行
   *
   */
  onDismiss: _propTypes2['default'].func,
  /**
   * 延时消失
   *
   */
  timeout: _propTypes2['default'].number
};
Tip.defaultProps = {
  status: 'success'
};

exports['default'] = _utilsBootstrapUtils.bsClass('Tip', Tip);
module.exports = exports['default'];